// Output generated from file: D:/fractal/Fragmentarium/Output/mclarekin/quatCubic4D-3_Files/1-6_Files/1-6.frag
// Created: Tue Aug 29 21:36:28 2017
// Output generated from file: D:/fractal/Fragmentarium/Output/mclarekin/quatCubic4D-3_Files/1-5_Files/1-5.frag
// Created: Tue Aug 29 21:23:05 2017
// Output generated from file: D:/fractal/Fragmentarium/Output/mclarekin/quatCubic4D-3_Files/1-1_Files/1-1.frag
// Created: Tue Aug 29 21:06:29 2017
// Output generated from file: D:/fractal/Fragmentarium/Output/mclarekin/quatCubic4D-3_Files/quatCubic4D-3.frag
// Created: Tue Aug 29 20:41:36 2017
// Output generated from file: C:/Users/Graeme/Fragmentarium/Examples/Historical 3D Fractals/QuaternionCubic4D.frag
// Created: Tue Aug 29 03:03:51 2017
#info 4D Quaternion Julia Distance Estimator
//#define USE_IQ_CLOUDS
//#define KN_VOLUMETRIC
//#define USE_EIFFIE_SHADOW
//#define MULTI_SAMPLE_AO
//#define AUTOFOCUS
#include "MathUtils.frag"
//#include "DE-kn2cr11.frag"
#include "newIQPath.frag"

//#include "DE-Raytracer.frag"
#group 4D Quaternion Cubic4D

// The DE implementation here is based on the implementation by Subblue:
//  http://www.subblue.com/blog/2009/9/20/quaternion_julia
// which in turn is based on a CG shader by Keenan Crane.
// twist from Darkbeams M3D
// coded by mclarekin for sabine


// Number of fractal iterations.
uniform int Iterations;  slider[0,16,100]
uniform int ColorIterations; slider[0,3,250]

// Breakout distance
uniform float Threshold; slider[0,10,100]


uniform float initialW; slider[-2,0,2]
uniform bool AbsX; checkbox[false]
uniform bool AbsY; checkbox[false]
uniform bool AbsZ; checkbox[false]
uniform bool AbsW; checkbox[false]
uniform bool Abs4D; checkbox[false]
uniform vec4 preScale; slider[(0,0,0,0),(1,1,1,1),(1,1,1,1)]
uniform float X_twist; slider[-2,0,2]
uniform float Y_twist; slider[-2,0,2]
uniform vec4 scale1222; slider[(0,0,0,0),(1,1,1,1),(5,5,5,5)]
uniform vec4 juliaC; slider[(-1,-1,-1,-1),(0,0,0,0),(1,1,1,1)]
uniform vec4 scaleC1111; slider[(0,0,0,0),(1,1,1,1),(5,5,5,5)]


float DE(vec3 pos) {

	vec4 p = vec4(pos, initialW);
	vec4 dp = vec4(1.0,0.0,0.0,0.0);
	vec4 initialC = p;
	vec4 C = initialC * scaleC1111;

	for (int i = 0; i < Iterations; i++) {
		if (AbsX) p.x = abs(p.x);
		if (AbsY) p.y = abs(p.y);
		if (AbsZ) p.z = abs(p.z);
		if (AbsW) p.w = abs(p.w);
		if (Abs4D) p=abs(p);
		vec4 mul = p * preScale;
		dp *= preScale;
		vec4 oldP = p;

		//dp = 2.0* vec4(p.x*dp.x-dot(p.yzw, dp.yzw), p.x*dp.yzw+dp.x*p.yzw+cross(p.yzw, dp.yzw));
		dp = 2.0* vec4(mul.x*dp.x-dot(mul.yzw, dp.yzw), mul.x*dp.yzw+dp.x*mul.yzw+cross(mul.yzw, dp.yzw));

		p.x = mul.x * p.x - mul.y * p.y - mul.z * p.z - mul.w * p.w + (C.y * X_twist);
		p.y =  oldP.y * oldP.x;
		p.z =  oldP.z * oldP.x;
		p.w =  oldP.w * oldP.x; 

		p *= scale1222;
		p.y += C.x * Y_twist;
		p += C + juliaC;

		float p2 = dot(p,p);
		orbitTrap = min(orbitTrap, abs(vec4(p.xyz,p2)));
		if (p2 > Threshold) break;
		if (i<ColorIterations) orbitTrap = min(orbitTrap, abs(vec4(p.x,p.y,p.z,p.w)));
	}
	float r = length(p);
	return  0.5 * r * log(r) / length(dp);
}


















#preset Default
OrbitStrength = 0.6429405
X = 0.5,0.6,0.6,1
Y = 1,0.6,0,1
Z = 0.8,0.78,1,1
R = 0.4,0.7,1,1
CycleColors = false
Cycles = 2.425959
RayBounces = 7
RaySteps = 179
FudgeFactor = 0.8153302
HitDistance = 0.00018
MaxDepth = 200
Mat_Color = 0.65,0.65,0.65
Mat_Refl = 1
Mat_ReflExp = 1
UseTexture = true
DeTex = D:/fractal/Mandelbulb3D/maps/27.jpg
DeTexScale = 0.662021
DeTexExposure = 1
SpotLight = 1,0.8,0.5,2.488095
SpotLightDir = -1,0.0662021
SpotSize = 10
SpotExp = 5.86096
BgColor = 0.3,0.5,0.7,1
Ambience = 1
Fog = 0.1209945
GRIter = 20
GRPower = 0.0238908
FOV = 0.4
Eye = -1.724932,0.2443673,-0.013869
Target = -0.5235195,-9.50425,-1.890324
Up = -0.0196063,0.1642634,-0.8659391
EquiRectangular = false
FocalPlane = 0.2447552
Aperture = 0.0076212
ApertureNbrSides = 7
ApertureRot = 0
ApStarShaped = true
BokehCircle = 1.7
Gamma = 1.052928
ToneMapping = 3
Exposure = 1
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Iterations = 99
ColorIterations = 5
Threshold = 10
initialW = 0
AbsX = false
AbsY = false
AbsZ = false
AbsW = false
Abs4D = true
preScale = 1,1,1,1
X_twist = 0
Y_twist = 0
scale1222 = 1,2,2,2
juliaC = 0,0,0,0
scaleC1111 = 1,1,1,1
#endpreset

